﻿//+--------------------------------------------------------------------------+
//|                                                                          |
//|                            SkinCaption class                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2006                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 11-09-2006 (MM-DD-YYYY)            |
//|                        Last revised : 11-10-2006 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using SkinEngine;
using Win32;

namespace BlackBox
{
    public partial class SkinCaption : System.Windows.Forms.Button
    {
        private bool CaptionMoving = false;
        private int xCapture = 0;
        private int yCapture = 0;

        public SkinCaption()
        {
            InitializeComponent();
            this.Name = "CAPTION_Label";
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case Api.WM_LBUTTONDBLCLK:
                    Api.SendMessage(Api.GetParent(m.HWnd), Api.WM_NCLBUTTONDBLCLK, Api.HTCAPTION, Api.MakeLong(Control.MousePosition.X, Control.MousePosition.Y));
                    m.Result = (IntPtr)0;
                    return;
                default:
                    base.WndProc(ref m);
                    break;
            }
        }

        private void CAPTION_MouseDown(object sender, MouseEventArgs e)
        {
            CaptionMoving = true;
            xCapture = e.X; yCapture = e.Y;
        }

        private void CAPTION_MouseMove(object sender, MouseEventArgs e)
        {
            if (CaptionMoving)
            {// Mimic HTCAPTION to move the parent window hover the desktop.
                int x = this.Location.X;
                int y = this.Location.Y;
                x = (e.X - xCapture) - (x - this.Parent.Location.X) + x;
                y = (e.Y - yCapture) - (y - this.Parent.Location.Y) + y;
                Api.MoveWindow(this.Parent.Handle, x, y, this.Parent.Width, this.Parent.Height, true);
            }
        }

        private void CAPTION_MouseUp(object sender, MouseEventArgs e)
        {
            CaptionMoving = false;
            xCapture = 0; yCapture = 0;
        }

    }
}
